org.jgrapht.graph

## Class EdgeReversedGraph<V,E>

- java.lang.Object
- - org.jgrapht.graph.AbstractGraph<V,E>
  - - org.jgrapht.graph.GraphDelegator<V,E>
    - - org.jgrapht.graph.EdgeReversedGraph<V,E>

- All Implemented Interfaces:
    Serializable, DirectedGraph<V,E>, Graph<V,E>

      public class EdgeReversedGraph<V,E>
      extends GraphDelegator<V,E>
      implements DirectedGraph<V,E>

  Provides an edge-reversed view g' of a directed graph g. The vertex sets for the two graphs are the same, but g' contains an edge (v2, v1) iff g contains an edge (v1, v2). g' is backed by g, so changes to g are reflected in g', and vice versa.

  This class allows you to use a directed graph algorithm in reverse. For example, suppose you have a directed graph representing a tree, with edges from parent to child, and you want to find all of the parents of a node. To do this, simply create an edge-reversed graph and pass that as input to `DepthFirstIterator`.

  Author:
    John V. Sichi
  See Also:
    `AsUndirectedGraph`, Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `EdgeReversedGraph(DirectedGraph<V,E> g)` Creates a new EdgeReversedGraph.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `E` | `addEdge(V sourceVertex, V targetVertex)` Creates a new edge in this graph, going from the source vertex to the target vertex, and returns the created edge.
    `boolean` | `addEdge(V sourceVertex, V targetVertex, E e)` Adds the specified edge to this graph, going from the source vertex to the target vertex.
    `Set<E>` | `getAllEdges(V sourceVertex, V targetVertex)` Returns a set of all edges connecting source vertex to target vertex if such vertices exist in this graph.
    `E` | `getEdge(V sourceVertex, V targetVertex)` Returns an edge connecting source vertex to target vertex if such vertices and such edge exist in this graph.
    `V` | `getEdgeSource(E e)` Returns the source vertex of an edge.
    `V` | `getEdgeTarget(E e)` Returns the target vertex of an edge.
    `Set<E>` | `incomingEdgesOf(V vertex)` Returns a set of all edges incoming into the specified vertex.
    `int` | `inDegreeOf(V vertex)` Returns the "in degree" of the specified vertex.
    `int` | `outDegreeOf(V vertex)` Returns the "out degree" of the specified vertex.
    `Set<E>` | `outgoingEdgesOf(V vertex)` Returns a set of all edges outgoing from the specified vertex.
    `E` | `removeEdge(V sourceVertex, V targetVertex)` Removes an edge going from source vertex to target vertex, if such vertices and such edge exist in this graph.
    `String` | `toString()` Returns a string of the parenthesized pair (V, E) representing this G=(V,E) graph.

    - ### Methods inherited from class org.jgrapht.graph.GraphDelegator

      `addVertex, containsEdge, containsVertex, degreeOf, edgeSet, edgesOf, getEdgeFactory, getEdgeWeight, removeEdge, removeVertex, setEdgeWeight, vertexSet`

    - ### Methods inherited from class org.jgrapht.graph.AbstractGraph

      `assertVertexExist, containsEdge, equals, hashCode, removeAllEdges, removeAllEdges, removeAllEdges, removeAllVertices, toStringFromSets`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.jgrapht.Graph

      `addVertex, containsEdge, containsEdge, containsVertex, edgeSet, edgesOf, getEdgeFactory, getEdgeWeight, removeAllEdges, removeAllEdges, removeAllVertices, removeEdge, removeVertex, vertexSet`

- - ### Constructor Detail

    - #### EdgeReversedGraph

          public EdgeReversedGraph(DirectedGraph<V,E> g)

      Creates a new EdgeReversedGraph.
      Parameters:
        `g` - the base (backing) graph on which the edge-reversed view will be based.

  - ### Method Detail

    - #### getEdge

          public E getEdge(V sourceVertex,
                  V targetVertex)

      Description copied from interface: `Graph`
      Returns an edge connecting source vertex to target vertex if such vertices and such edge exist in this graph. Otherwise returns `null`. If any of the specified vertices is `null` returns `null`

      In undirected graphs, the returned edge may have its source and target vertices in the opposite order.

      Specified by:
        `getEdge` in interface `Graph<V,E>`
      Overrides:
        `getEdge` in class `GraphDelegator<V,E>`
      Parameters:
        `sourceVertex` - source vertex of the edge.
        `targetVertex` - target vertex of the edge.
      Returns:
        an edge connecting source vertex to target vertex.
      See Also:
        `Graph.getEdge(Object, Object)`

    - #### getAllEdges

          public Set<E> getAllEdges(V sourceVertex,
                           V targetVertex)

      Description copied from interface: `Graph`
      Returns a set of all edges connecting source vertex to target vertex if such vertices exist in this graph. If any of the vertices does not exist or is `null`, returns `null`. If both vertices exist but no edges found, returns an empty set.

      In undirected graphs, some of the returned edges may have their source and target vertices in the opposite order. In simple graphs the returned set is either singleton set or empty set.

      Specified by:
        `getAllEdges` in interface `Graph<V,E>`
      Overrides:
        `getAllEdges` in class `GraphDelegator<V,E>`
      Parameters:
        `sourceVertex` - source vertex of the edge.
        `targetVertex` - target vertex of the edge.
      Returns:
        a set of all edges connecting source vertex to target vertex.
      See Also:
        `Graph.getAllEdges(Object, Object)`

    - #### addEdge

          public E addEdge(V sourceVertex,
                  V targetVertex)

      Description copied from interface: `Graph`
      Creates a new edge in this graph, going from the source vertex to the target vertex, and returns the created edge. Some graphs do not allow edge-multiplicity. In such cases, if the graph already contains an edge from the specified source to the specified target, than this method does not change the graph and returns `null`.

      The source and target vertices must already be contained in this graph. If they are not found in graph IllegalArgumentException is thrown.

      This method creates the new edge `e` using this graph's `EdgeFactory`. For the new edge to be added `e` must not be equal to any other edge the graph (even if the graph allows edge-multiplicity). More formally, the graph must not contain any edge `e2` such that `e2.equals(e)`. If such `e2` is found then the newly created edge `e` is abandoned, the method leaves this graph unchanged returns `null`.

      Specified by:
        `addEdge` in interface `Graph<V,E>`
      Overrides:
        `addEdge` in class `GraphDelegator<V,E>`
      Parameters:
        `sourceVertex` - source vertex of the edge.
        `targetVertex` - target vertex of the edge.
      Returns:
        The newly created edge if added to the graph, otherwise `null`.
      See Also:
        `Graph.addEdge(Object, Object)`

    - #### addEdge

          public boolean addEdge(V sourceVertex,
                        V targetVertex,
                        E e)

      Description copied from interface: `Graph`
      Adds the specified edge to this graph, going from the source vertex to the target vertex. More formally, adds the specified edge, `e`, to this graph if this graph contains no edge `e2` such that `e2.equals(e)`. If this graph already contains such an edge, the call leaves this graph unchanged and returns `false`. Some graphs do not allow edge-multiplicity. In such cases, if the graph already contains an edge from the specified source to the specified target, than this method does not change the graph and returns `false`. If the edge was added to the graph, returns `true`.

      The source and target vertices must already be contained in this graph. If they are not found in graph IllegalArgumentException is thrown.

      Specified by:
        `addEdge` in interface `Graph<V,E>`
      Overrides:
        `addEdge` in class `GraphDelegator<V,E>`
      Parameters:
        `sourceVertex` - source vertex of the edge.
        `targetVertex` - target vertex of the edge.
        `e` - edge to be added to this graph.
      Returns:
        `true` if this graph did not already contain the specified edge.
      See Also:
        `Graph.addEdge(Object, Object, Object)`

    - #### inDegreeOf

          public int inDegreeOf(V vertex)

      Description copied from interface: `DirectedGraph`
      Returns the "in degree" of the specified vertex. An in degree of a vertex in a directed graph is the number of inward directed edges from that vertex. See http://mathworld.wolfram.com/Indegree.html.
      Specified by:
        `inDegreeOf` in interface `DirectedGraph<V,E>`
      Overrides:
        `inDegreeOf` in class `GraphDelegator<V,E>`
      Parameters:
        `vertex` - vertex whose degree is to be calculated.
      Returns:
        the degree of the specified vertex.
      See Also:
        `DirectedGraph.inDegreeOf(Object)`

    - #### outDegreeOf

          public int outDegreeOf(V vertex)

      Description copied from interface: `DirectedGraph`
      Returns the "out degree" of the specified vertex. An out degree of a vertex in a directed graph is the number of outward directed edges from that vertex. See http://mathworld.wolfram.com/Outdegree.html.
      Specified by:
        `outDegreeOf` in interface `DirectedGraph<V,E>`
      Overrides:
        `outDegreeOf` in class `GraphDelegator<V,E>`
      Parameters:
        `vertex` - vertex whose degree is to be calculated.
      Returns:
        the degree of the specified vertex.
      See Also:
        `DirectedGraph.outDegreeOf(Object)`

    - #### incomingEdgesOf

          public Set<E> incomingEdgesOf(V vertex)

      Description copied from interface: `DirectedGraph`
      Returns a set of all edges incoming into the specified vertex.
      Specified by:
        `incomingEdgesOf` in interface `DirectedGraph<V,E>`
      Overrides:
        `incomingEdgesOf` in class `GraphDelegator<V,E>`
      Parameters:
        `vertex` - the vertex for which the list of incoming edges to be returned.
      Returns:
        a set of all edges incoming into the specified vertex.
      See Also:
        `DirectedGraph.incomingEdgesOf(Object)`

    - #### outgoingEdgesOf

          public Set<E> outgoingEdgesOf(V vertex)

      Description copied from interface: `DirectedGraph`
      Returns a set of all edges outgoing from the specified vertex.
      Specified by:
        `outgoingEdgesOf` in interface `DirectedGraph<V,E>`
      Overrides:
        `outgoingEdgesOf` in class `GraphDelegator<V,E>`
      Parameters:
        `vertex` - the vertex for which the list of outgoing edges to be returned.
      Returns:
        a set of all edges outgoing from the specified vertex.
      See Also:
        `DirectedGraph.outgoingEdgesOf(Object)`

    - #### removeEdge

          public E removeEdge(V sourceVertex,
                     V targetVertex)

      Description copied from interface: `Graph`
      Removes an edge going from source vertex to target vertex, if such vertices and such edge exist in this graph. Returns the edge if removed or `null` otherwise.
      Specified by:
        `removeEdge` in interface `Graph<V,E>`
      Overrides:
        `removeEdge` in class `GraphDelegator<V,E>`
      Parameters:
        `sourceVertex` - source vertex of the edge.
        `targetVertex` - target vertex of the edge.
      Returns:
        The removed edge, or `null` if no edge removed.
      See Also:
        `Graph.removeEdge(Object, Object)`

    - #### getEdgeSource

          public V getEdgeSource(E e)

      Description copied from interface: `Graph`
      Returns the source vertex of an edge. For an undirected graph, source and target are distinguishable designations (but without any mathematical meaning).
      Specified by:
        `getEdgeSource` in interface `Graph<V,E>`
      Overrides:
        `getEdgeSource` in class `GraphDelegator<V,E>`
      Parameters:
        `e` - edge of interest
      Returns:
        source vertex
      See Also:
        `Graph.getEdgeSource(Object)`

    - #### getEdgeTarget

          public V getEdgeTarget(E e)

      Description copied from interface: `Graph`
      Returns the target vertex of an edge. For an undirected graph, source and target are distinguishable designations (but without any mathematical meaning).
      Specified by:
        `getEdgeTarget` in interface `Graph<V,E>`
      Overrides:
        `getEdgeTarget` in class `GraphDelegator<V,E>`
      Parameters:
        `e` - edge of interest
      Returns:
        target vertex
      See Also:
        `Graph.getEdgeTarget(Object)`

    - #### toString

          public String toString()

      Description copied from class: `AbstractGraph`
      Returns a string of the parenthesized pair (V, E) representing this G=(V,E) graph. 'V' is the string representation of the vertex set, and 'E' is the string representation of the edge set.
      Overrides:
        `toString` in class `GraphDelegator<V,E>`
      Returns:
        a string representation of this graph.
      See Also:
        `Object.toString()`

Copyright © 2016. All rights reserved.